
putlog "-"
putlog "Beginning of a loading IRC-Arena"
putlog "-"

###      (, , ...)
set linkrules "http://twin.net.ru/arena/"

set arenadir "scripts/mc/"

### config.tcl must be first
source ${arenadir}mc.config.tcl
source ${arenadir}mc.theme.tcl
source ${arenadir}mc.utils.tcl
source ${arenadir}mc.user.tcl
source ${arenadir}mc.binds.tcl
source ${arenadir}mc.misc.tcl
source ${arenadir}mc.reg.tcl
source ${arenadir}mc.game.tcl
source ${arenadir}mc.shop.tcl
source ${arenadir}mc.round.tcl
source ${arenadir}mc.irc.tcl
source ${arenadir}mc.com.tcl
source ${arenadir}mc.ctools.tcl
source ${arenadir}mc.twin.tcl
source ${arenadir}mc.senna.tcl
source ${arenadir}mc.hosts.tcl

if { ![array exist mc] || ![info exist mc(ver)]} {
    set mc(ver) "2.0.1a3"
    set mc(cop) "IRC-Arena \[$mc(ver)\]"

    set mc(chan)  "#combats"

    set mc(phase) 0
    set mc(flags) ""

    set noreg 0
    cleartimers
    utimer 1 {
        mc:log "Maiden start - Auto-rehash"
        rehash
    }
}

set mc(rules) "${arenadir}rules.txt"
set mc(file.base) "bots/arena.$network.$nick.base"
set mc(file.skil) "bots/arena.$network.$nick.skill"
set mc(file.coms) "bots/arena.$network.$nick.coms"
set mc(file.save) "bots/arena.$network.$nick.save"
set mc(file.drop) "bots/arena.$network.$nick.drop"
set mc(file.nexp) "bots/arena.$network.$nick.nexp"
set mc(file.bots) "bots/arena.$network.$nick.bots"
set mc(file.host) "bots/arena.$network.$nick.host"
set mc(file.conf) "bots/arena.$network.$nick.conf"
set mc(file.recs) "bots/arena.$network.$nick.records"
set mc(file.phtml) "${arenadir}players.stats"
set mc(file.chtml) "${arenadir}coms.stats"

###  
set mc(nocom) 1

###     
###             .-    
###             |   .-      ..
set mc(maxlvl) "3 2 1"
###        - 

###  public- (botnet-nick).
set mc(bot.public) "mflood"

###  -.      . [0/..]
### 11  1-  1- 
set mc(sptitles) 11
###  .      . [0/..]
set mc(stitles) 11
###   .      . [0/..]
set mc(sraces) 1

###   . [1/0]
set mc(coding) 0
###      . [1/0]
set mc(loadbase) 1
###      . [1/0]
set mc(savebase) 1
###      ctime, ltime ( ).   -2 .
set mc(timeshift) -7200
###   HTML  .
set mc(generatehtml) 1
###         [0/1-24]
set mc(backupbase) 6

###  +-m  .
set mc(moderating) 1

###      .
set mc(regkicks) 1

###       (RFC....). [1/0]
set mc(massmsg) 1

###    . [1/0]
set mc(nonewchar) 0
###       .
set mc(maxnicklength) 20

###    .
set mc(gamemaxexp) 1000

###     !top.  0,    .
set mc(topsize) 0
###     ,   .
set mc(avegold) 25
###      .
set mc(maxgold) 75
###     ,    .
set mc(avegamers) 20
###  ,       ,   .
set mc(multilist) 1

###        
set mc(maxhitten) 5

### ID ,   
set mc(noregteams) "{newbie*} {.*}"

###    DCC
set mc(dccport1) 4421
set mc(dccport2) 4422

###    !ready  
set mc(killregsleep) 90

###    !look  
set mc(lastlook)   5
###    !list  
set mc(lastlist)   30
###    !com   
set mc(lastcom1)   40
###    !com   
set mc(lastcom2)   75
###    !moves   
set mc(lastmoves1) 40
###    !moves   
set mc(lastmoves2) 75
###    !pool    
set mc(lastpool)   60
###    !cex    
set mc(lastcex)    40
###    !top  
set mc(lasttop)    180

###  .      .. 
###           |------------------------------------------------- Enable testing
###           | |----------------------------------------------- Register level
###           | |  |-------------------------------------------- Register remort
###           | |  |  |----------------------------------------- Register exp
###           | |  |  |      |---------------------------------- Register gold
###           | |  |  |      |     |---------------------------- Register bonus
###           | |  |  |      |     |  |------------------------- Register str
###           | |  |  |      |     |  |   |--------------------- Register dex
###           | |  |  |      |     |  |   |   |----------------- Register wis
###           | |  |  |      |     |  |   |   |   |------------- Register int
###           | |  |  |      |     |  |   |   |   |   |--------- Register con
###           | |  |  |      |     |  |   |   |   |   |   |----- Register free
###           | |  |  |      |     |  |   |   |   |   |   |  |-- Register favor
set mc(test) "0 5  0  25000  10000 5  30  30  30  30  30  10 0"

###   
set mc(startmagicl) "{- -}"
set mc(startmagicm) "{1ma 3}"
set mc(startmagicp) "{1pa 3}"
set mc(startmagicw) "{- -}"
###  
set mc(startskilll) "{- -} {la 1}"
set mc(startskillm) "{- -}"
set mc(startskillp) "{- -}"
set mc(startskillw) "{- -} {wa 1}"
###  
set mc(startregeql) "{waa 0 1 a {}}"
set mc(startregeqm) "{waa 0 1 a {}}"
set mc(startregeqp) "{waa 0 1 a {}}"
set mc(startregeqw) "{waa 0 1 a {}}"

if { ![info exist mc(limit)] }       { set mc(limit) 35      }
if { ![info exist mc(alevel)] }      { set mc(alevel) 5      }
if { ![info exist mc(alreadyhtml)] } { set mc(alreadyhtml) 1 }

mc:setbinds "$mc(chan)"

if { ![array exist mcs] } {
    mc:read
    mc:readrecords
    mc:calcaveragelevel
}

source ${arenadir}mc.telnet.tcl
source ${arenadir}mc.pool.tcl
source ${arenadir}mc.magic.tcl
source ${arenadir}mc.skill.tcl
source ${arenadir}mc.cskill.tcl
source ${arenadir}mc.constants.tcl
source ${arenadir}mc.esets.tcl
source ${arenadir}mc.favor.tcl
source ${arenadir}mc.collect.tcl
source ${arenadir}mc.talisman.tcl
source ${arenadir}mc.spec.tcl
source ${arenadir}mc.mode.tcl
source ${arenadir}mc.html.tcl
source ${arenadir}mc.update.tcl
source ${arenadir}mc.savelist.tcl
source ${arenadir}mc.transfer.tcl
source ${arenadir}mc.weather.tcl

#source ${arenadir}mc.public.tcl
#source ${arenadir}mc.botnet.tcl
#source ${arenadir}mc.create.tcl

putlog "-"

###      ,    
if { [mc:isbot public] } {
    putlog "Is public bot."

    set noreg 1
    set types "msgm msg pub pubm notc dcc part sign kick nick join rejn splt time"

    foreach ee [binds "*mc:*"] {
        set type [lindex $ee 0]
        if { [lsearch -exact $types $type] != -1 } {
            unbind [lindex $ee 0] [lindex $ee 1] [lindex $ee 2] [lindex $ee 4]
        }
    }
    bind msgm - "!reg*"                                     mc:public:reg
} else {
  putlog "Is main bot."
#  source ${arenadir}mc.total.server.tcl
#  source ${arenadir}mc.total.client.tcl
#  source ${arenadir}mc.total.theme.tcl
}

mc:config:register nocom        bool 0    .
mc:config:register generatehtml bool 0   HTML .
mc:config:register backupbase   int  6         \[0/1-24\]
mc:config:register noselfattack bool 1    .
mc:config:register weather.enbl bool 0   .

mc:config:load

putlog "ArenaVer : $mc(ver)"
putlog "BotAdmin : $admin"
putlog "DropVer  : [lindex $version 0]"
putlog "-"
putlog "IRC-Arena is loaded."
putlog "-"
