
### ###############################################################################
### # Filename: mc.magic.tcl                                                      #
### #                                                                             #
### # Description:                                                                #
### #      /                                      #
### ###############################################################################

#     1
proc mc:decrcount {list targ} {
    set pos [mc:getpos $list $targ]
    if {$pos != -1} {
      set count [expr [lindex [lindex $list $pos] 1] - 1]
      set list [lreplace $list $pos $pos "$targ $count"]
    }
    return $list
}

proc mc:getpos {list targ} {
    set pos -1
    set i 0
    foreach char $list {
        if {[lindex $char 0] == $targ} {
            set pos $i
            break
        }
        incr i
    }

    return $pos
}

proc mc:appendcount {list targ} {
    set pos [mc:getpos $list $targ]

    if {$pos == -1} {
        set list [lappend list "$targ 1"]
    } else {
        set count [expr [lindex [lindex $list $pos] 1] + 1]
        set list [lreplace $list $pos $pos "$targ $count"]
    }

    return $list
}

proc mc:newshow {list pos targ time hits exp} {
    if {$pos == -1} {
        #  ,    
        set newshow "$targ {$time} $hits $exp"
        set list [lappend list $newshow]
    } else {
        #     ,   
        set newshow [lindex $list $pos]
        set showtime [lindex $newshow 1]
        set showtime [lsort -integer [lappend showtime $time]]
        set showhits [expr [lindex $newshow 2] + $hits]
        set showexp  [expr [lindex $newshow 3] + $exp]
        set newshow "$targ {$showtime} $showhits $showexp"
        set list [lreplace $list $pos $pos $newshow]
    }
    set ret ""
    set ret [lappend ret $newshow]
    set ret [lappend ret $list]
    return $ret
}

proc mc:getmaxcount {list targ} {
    set maxcount 0

    foreach char $list {
        if {[lindex $char 0] == $targ} {
            set maxcount [lindex $char 1]
            break
        }
    }

    return $maxcount
}

###       /
proc mc:operation:delete {iii {type "spell"}} {
    global mgtypei mgmanai mglevi mgprci mgtimei mghlongi mgstri mgid targi mgexp
    global sklid skltarg skltype skllev sklprc sklprice sklexp sklpass

    switch -- $type {
        "spell" {
            if { [info exists  mgtypei($iii)] } { unset mgtypei($iii)  }
            if { [info exists  mgmanai($iii)] } { unset mgmanai($iii)  }
            if { [info exists   mglevi($iii)] } { unset mglevi($iii)   }
            if { [info exists   mgprci($iii)] } { unset mgprci($iii)   }
            if { [info exists  mgtimei($iii)] } { unset mgtimei($iii)  }
            if { [info exists mghlongi($iii)] } { unset mghlongi($iii) }
            if { [info exists   mgstri($iii)] } { unset mgstri($iii)   }
            if { [info exists     mgid($iii)] } { unset mgid($iii)     }
            if { [info exists    targi($iii)] } { unset targi($iii)    }
            if { [info exists    mgexp($iii)] } { unset mgexp($iii)    }
        }
        "skill" {
            if { [info exists    sklid($iii)] } { unset sklid($iii)    }
            if { [info exists  skltarg($iii)] } { unset skltarg($iii)  }
            if { [info exists  skltype($iii)] } { unset skltype($iii)  }
            if { [info exists   skllev($iii)] } { unset skllev($iii)   }
            if { [info exists   sklprc($iii)] } { unset sklprc($iii)   }
            if { [info exists sklprice($iii)] } { unset sklprice($iii) }
            if { [info exists   sklexp($iii)] } { unset sklexp($iii)   }
            if { [info exists  sklpass($iii)] } { unset sklpass($iii)  }
        }
    }
}

###     /
proc mc:operation:getparam {num param {type "spell"}} {
    global mgtypei mgmanai mglevi mgprci mgtimei mghlongi mgstri mgid targi mgexp
    global sklid skltarg skltype skllev sklprc sklprice sklexp sklpass

    switch -- $type {
        "spell" {
            switch -- $param {
                "id"     { return $mgid($num) }
                "targ"   { return $targi($num) }
                "victim" { return $targi($num) }
                "type"   { return $mgtypei($num) }
                "level"  { return $mglevi($num) }
                "mana"   { return $mgmanai($num) }
                "price"  { return $mgmanai($num) }
                "prc"    { return $mgprci($num) }
                "time"   { return $mgtimei($num) }
                "long"   { return $mghlongi($num) }
                "str"    { return $mgstri($num) }
                "exp"    { return $mgexp($num) }
            }
        }
        "skill" {
            switch -- $param {
                "id"     { return $sklid($num) }
                "targ"   { return $skltarg($num) }
                "victim" { return $skltarg($num) }
                "type"   { return $skltype($num) }
                "level"  { return $skllev($num) }
                "mana"   { return $sklprice($num) }
                "price"  { return $sklprice($num) }
                "prc"    { return $sklprc($num) }
                "pass"   { return $sklpass($num) }
                "exp"    { return $sklexp($num) }
            }
        }
    }
}

###        
proc mc:magic:permanentfail {id mid} {
    global ctm mimmun nospellto

    set why ""
    if { [lsearch -exact $mimmun($id) $mid] != -1 }    { set why [lappend why $ctm(mfi)] }
    if { [lsearch -exact $nospellto($id) $mid] != -1 } { set why [lappend why $ctm(mff)] }
    if { $why != "" } { set why [format $ctm(mf) [join $why ", "] ] }

    return $why
}

proc mc:magic:getstat {stt mg} {
  global spells

  if {[info exist spells($mg)]} {
    array set mgrec $spells($mg)
    if {[info exist mgrec($stt)]} {
      return $mgrec($stt)
    }
  }

  putlog "Error in <magic:getstat> $mg $stt"
  return 0
}

proc mc:magic:xgetver {mgrec} {
  global spells
  array set mag $mgrec
  if {[info exist spells($mag(type))]} {
    return [mcmg:$mag(type):ver $mag(level) $mag(id) $mag(targ) $mag(prc)]
  }
  putlog "Error in <magic:xgetver> $mgrec"
  return 0
}

proc mc:magic:xgetlong {mgrec} {
  array set mag $mgrec
  return [mcmg:$mag(type):long $mag(level) $mag(id)]
}

proc mc:magic:runspell {mgrec} {
  global id targ attnick trgnick level nnick param
  global time long
  array set mag $mgrec
  set id $mag(id)
  set targ $mag(targ)
  set attnick $mag(attnick)
  set trgnick $mag(trgnick)
  set level   $mag(level)
  set aprc    $mag(prc)
  set type    $mag(type)
  set level   $mag(level)
  set attstr  $mag(level)
  set time    $mag(time)
  set long    $mag(long)
  set uid     $mag(uid)

  if {$time == 0} {
    lappend param($targ) "$id $aprc $targ $type $level $attstr $time $long $uid"
  }
  incr time
  return [mcmg:$mag(type):run]
}

proc mc:magic:load {} {
  global mgload mc lstr errstr spells

  set fnl [glob -directory $mc(file.mage) "*.magic"]
  if {[array exist spells]} { unset spells }
  set spells(-) 0
  unset spells(-)

  foreach lstr $fnl {
    if {[catch {uplevel #0 {source $lstr}} errstr]} {
      putlog "Error while load magic ${lstr}: $errstr"
    } else {
      array set mgload [spell_init]
      if {[info exist spells($mgload(code))]} {
        putlog "Warning! Duplicate mage: $lstr"
      } {
        set spells($mgload(code)) [array get mgload]
      }
    }
  }
  putlog "Loaded [array size spells] spell's."
}

proc mc:magic:runpostspell {} {
  global spells

  foreach spell [array names spells] {
    if {[mc:magic:getstat postmode $spell]} {
      mcmg:$spell:post
    }
  }
}

proc mc:magic:exist {mg} {
  global spells

  return [info exist spells($mg)]
}
