# source mc.ctools.tcl
# source mc.misc.tcl

if {![info exist mc(tot.server)]} {
  set mc(tot.server) "JuDeX"
  set mc(tot.chan)   "#arena.total"
  set mc(tot.debug)  0
  putlog "...Loading client part of Arena-total..."
}

bind bot - arena.total  mc:tot:parsefromserver

proc mc:tot:say {num {args ""}} {
  global mc tthm
  if {[info exist tthm($num)]} { set num $tthm($num) }
  if {[llength $args] != 0} { set num [eval "format \$num $args"] }
  putquick "PRIVMSG $mc(tot.chan) :$num"
}

proc mc:tot:tsay {nk num {args ""}} {
  global mc tthm
  if {[info exist tthm($num)]} { set num $tthm($num) }
  if {[llength $args] != 0} { set num [eval "format \$num $args"] }
  putquick "PRIVMSG $mc(tot.chan) :[format $tthm(tsay) [ms:dfl $nk] $num]"
}

proc mc:tot:nsay {nk num {args ""}} {
  global mc tthm
  if {[info exist tthm($num)]} { set num $tthm($num) }
  if {[llength $args] != 0} { set num [eval "format \$num $args"] }
  putquick "NOTICE [ms:dfl $nk] :$num"
}


proc mc:tot:setbinds {c} {
  global mc

  foreach ee [binds "*mc:tot:*"] {
    if { [lindex $ee 0] != "bot" || [lindex $ee 0] == "join" || [lindex $ee 0] == "rejn"} {
      unbind [lindex $ee 0] [lindex $ee 1] [lindex $ee 2] [lindex $ee 4]
    }
  }

  set mc(tot.chan) $c
  bind pubm - "$c !% %"      mc:tot:pub_bet
  bind pubm - "$c !c % %"    mc:tot:cpub_bet
  bind pubm - "$c !stat"     mc:tot:pub_stat
  bind pubm - "$c !bets"     mc:tot:pub_bets
  bind join - "$c *"         mc:tot:cljoin
  bind rejn - "$c *"         mc:tot:cljoin
}

proc mc:tot:cljoin {n uh h c} {
  mc:tot:toserver join [ms:fl $n]
}

proc mc:tot:toserver {cm param} {
   global mc

   if {[islinked $mc(tot.server)]} {
     putbot $mc(tot.server) "arena.total $cm [mc:tobotnet $param]"
   } elseif {[info exist mc(tot.client)]} {
     mc:tot:parsefromclient $mc(tot.client) "arena.total" "$cm [mc:tobotnet $param]"
     if {$mc(tot.debug)} { putlog ">server $cm [mc:tobotnet $param]" }
   }
}

proc mc:tot:pub_bets {n uh h c t} {
  mc:tot:toserver bets [ms:fl $n]
}


proc mc:tot:pub_bet {n uh h c t} {
  set num [string range [lindex $t 0] 1 end]
  set bet [lindex $t 1]

  if {[isnumber $num] && [isnumber $bet]} {
     mc:tot:toserver bet "[ms:fl $n] $num $bet"
  }
}

proc mc:tot:cpub_bet {n uh h c t} {
  set num [lindex $t 1]
  set bet [lindex $t 2]

  if {[isnumber $num] && [isnumber $bet]} {
     mc:tot:toserver cbet "[ms:fl $n] $num $bet"
  }
}

proc mc:tot:pub_stat {n uh h c t} {
   mc:tot:toserver stat [ms:fl $n]
}

proc mc:tot:saylist {n} {
  global mc tthm

  set i 1
  set out ""
  foreach nk $mc(tot.list) {
    if {[string length $out]>250} {
      set out [ms:dfl [join $out $tthm(nl.div)]]
      if {$n=="!"} { mc:tot:say nl $out } { mc:tot:nsay $n nl $out }
      set out ""
    }
    set out [lappend out [format $tthm(nl.nik) $i $nk]]
    incr i
  }
  if {$out!=""} {
    set out [ms:dfl [join $out $tthm(nl.div)]]
    if {$n=="!"} { mc:tot:say nl $out } { mc:tot:nsay $n nl $out }
  }
}

proc mc:tot:sayclist {n} {
  global mc tthm

  set i 1
  set out ""
  foreach nk $mc(tot.cl.clist) {
    if {[string length $out]>250} {
      set out [ms:dfl [join $out $tthm(nl.div)]]
      if {$n=="!"} { mc:tot:say cm $out } { mc:tot:nsay $n cm $out }
      set out ""
    }
    set out [lappend out [format $tthm(nl.com) $i $nk]]
    incr i
  }
  if {$out!=""} {
    set out [ms:dfl [join $out $tthm(nl.div)]]
    if {$n=="!"} { mc:tot:say cm $out } { mc:tot:nsay $n cm $out }
  }
}


proc mc:tot:nicklist {t} {
  global mc tthm

  mc:tot:say nl.strt [lindex $t 0]
  set mc(tot.list) [lrange $t 1 end]
  mc:tot:saylist !
}

proc mc:tot:clendgame {t} {
   global mc tthm

   set kl [lindex $t 0]
   set wl [lindex $t 1]
   set dp [lindex $t 2]

   if {[llength $kl]==0} {
     mc:tot:say ge.nokl
   } else {
     mc:tot:say ge.kllt [ms:dfl [join $kl $tthm(ge.nkjn)]]
   }

   if {[llength $wl]==0} {
     mc:tot:say cc.nope $dp
   } else {
     foreach wn $wl {
       mc:tot:tsay [lindex $wn 0] cc.win [lindex $wn 1]
     }
   }
}

proc mc:tot:roundend {t} {
   global mc tthm

   set kl [lindex $t 0]
   set wl [lindex $t 1]
   set dp [lindex $t 2]

   if {[llength $kl]==0} {
     mc:tot:say re.nokl
   } else {
     mc:tot:say re.kllt [ms:dfl [join $kl $tthm(re.nkjn)]]
   }

   if {[llength $wl]==0} {
     mc:tot:say wl.nope $dp
   } else {
     foreach wn $wl {
       mc:tot:tsay [lindex $wn 0] wl.win [lindex $wn 1]
     }
   }
}

proc mc:tot:betreply {t} {
  global mc

  set flag   [lindex $t 0]
  set id     [lindex $t 1]
  set bnick  [ms:dfl [lindex $t 2]]
  set bmoney [lindex $t 3]

  switch -- $flag {
    0  { mc:tot:tsay $id 0 $bnick $bmoney }
    1  { mc:tot:tsay $id 1 $bnick $bmoney }
    2  { mc:tot:tsay $id 2 $bmoney }
    3  { mc:tot:tsay $id 3 }
    4  { mc:tot:tsay $id 4 $bmoney }
    5  { mc:tot:tsay $id 5 }
    6  { mc:tot:tsay $id 6 }
    7  { mc:tot:tsay $id 7 }
    8  { mc:tot:tsay $id 8  $bnick $bmoney }
    9  { mc:tot:tsay $id 9  $bnick $bmoney }
    10 { mc:tot:tsay $id 10 $bnick }
    11 { mc:tot:tsay $id 11 $bmoney }
  }
}

proc mc:tot:cbetreply {t} {
  global mc

  set flag   [lindex $t 0]
  set id     [lindex $t 1]
  set bnick  [ms:dfl [lindex $t 2]]
  set bmoney [lindex $t 3]

  switch -- $flag {
    0  { mc:tot:tsay $id c0 $bnick $bmoney }
    1  { mc:tot:tsay $id c1 $bnick $bmoney }
    2  { mc:tot:tsay $id c2 $bmoney }
    3  { mc:tot:tsay $id 3 }
    4  { mc:tot:tsay $id c4 $bmoney }
    5  { mc:tot:tsay $id c5 }
    6  { mc:tot:tsay $id c6 }
    7  { mc:tot:tsay $id 7 }
    8  { mc:tot:tsay $id c8  $bnick $bmoney }
    9  { mc:tot:tsay $id c9  $bnick $bmoney }
    10 { mc:tot:tsay $id c10 $bnick }
    11 { mc:tot:tsay $id c11 $bmoney }
  }
}

proc mc:tot:statreply {t} {
   mc:tot:tsay [lindex $t 0] stat [lindex $t 1] [lindex $t 2]
}

proc mc:tot:bsaylist {t} {
  mc:tot:saylist $t
}

proc mc:tot:saybets {t} {
  global mc tthm

  set bb [lindex $t 1]

  if {[llength $bb]!=0} {
    set out ""
    foreach b $bb {
       set out [lappend out [format $tthm(bsbt) [lindex $b 1] [lindex $b 2]]]
    }
    mc:tot:tsay [lindex $t 0] btsy [ms:dfl [join $out $tthm(bsjn)]]
  } { mc:tot:tsay [lindex $t 0] bsno }
}

proc mc:tot:donecomlist {t} {
   global mc

   mc:tot:say nl.strt2 $t
   mc:tot:sayclist !
}

proc mc:tot:parsefromserver {bn cm t} {
   global mc

   if {[string tolower $bn] != [string tolower $mc(tot.server)]} { return }
   set cm [lindex $t 0]
   set t [mc:unbotnet [lrange $t 1 end]]

   switch -- $cm {
      betreply  { mc:tot:betreply  $t }
      nicklist  { mc:tot:nicklist  $t }
      roundend  { mc:tot:roundend  $t }
      statreply { mc:tot:statreply $t }
      saylist   { mc:tot:bsaylist  $t }
      saybets   { mc:tot:saybets   $t }
      initcomlist { set mc(tot.cl.clist) "" }
      addcomlist  { set mc(tot.cl.clist) [lappend mc(tot.cl.clist) $t] }
      donecomlist { mc:tot:donecomlist $t }
      cbetreply   { mc:tot:cbetreply   $t }
      clendgame   { mc:tot:clendgame   $t }
      cdisable    { mc:tot:say cdisable }
   }
}

mc:tot:setbinds $mc(tot.chan)